<?php
// +-----------------------------------------------------------------------+
// | Mod Name : secureImages                                               |
// | Mod Version : 0.4                                                     |
// | Mod Orignal author: acp <iacp@free.fr>                                |
// | Mod description : see install files                                   |
// |                                                                       |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

$secureImages_error_labels = array(
  'SECUREIMAGES-HTACCESS-NOT-WRITEABLE' => array(
    'The file (or directory) is not writable',
    'You need to give permission to the script to write to all your galleries subdirectories, or create the .htaccess files and give write access only to them.'
    ),
  'SECUREIMAGES-HTACCESS-NOT-REMOVABLE' => array(
    'The file (or directory) can not be removed',
    'You do not seem to have the necessary rights to remove this file.'
    ),
  'SECUREIMAGES-UNKNOWN' => array(
    'Unkown error',
    'Something went wrong. If you cannot find a solution, post a message to phpwebgallery forums for guidance. You might have found a bug.'
    )
);


function secureImages_htaccess_creation($simulate = FALSE) {
  if (!defined('PHPWG_ROOT_PATH'))
  {
    die('Hacking attempt!');
  }

  $opts['category_id'] = '';
  $opts['recursive'] = true;

  if (isset($_POST['cat']))
  {
    $opts['category_id'] = $_POST['cat'];
    // recursive ?
    if (!isset($_POST['subcats-included']) or $_POST['subcats-included'] != 1)
    {
      $opts['recursive'] = false;
    }
  }
  //  $start = get_moment();
  if (!isset($site_id))
    $site_id = 1;

  // filling $cat_ids : all categories required
  $cat_ids = array();

  $query = '
    SELECT id
      FROM '.CATEGORIES_TABLE.'
      WHERE site_id = '.$site_id.'
      AND dir IS NOT NULL';
  if (is_numeric($opts['category_id']))
  {
    if ($opts['recursive'])
    {
      $query.= '
        AND uppercats REGEXP \'(^|,)'.$opts['category_id'].'(,|$)\'
        ';
    }
    else
    {
      $query.= '
        AND id = '.$opts['category_id'].'
        ';
    }
  }
  $query.= '
    ;';
  $result = pwg_query($query);
  while ($row = mysql_fetch_array($result))
  {
    array_push($cat_ids, $row['id']);
  }

  if (count($cat_ids) == 0)
  {
    break;
  }

  $cat_fulldirs = get_fulldirs($cat_ids);

  $files = array();

  $query = '
    SELECT images.id, path, storage_category_id, GROUP_CONCAT(DISTINCT status) AS status
      FROM '.IMAGES_TABLE.' AS images
        JOIN '.IMAGE_CATEGORY_TABLE.' AS image_category
          ON images.id = image_category.image_id 
        JOIN '.CATEGORIES_TABLE.' AS categories
          ON image_category.category_id = categories.id 
      WHERE images.storage_category_id IN ('.implode(',', $cat_ids).')' .
      ( isset($_POST['file_types']) ? // Do not include files whose extension is 
          ' AND path NOT LIKE "%.' .  // in the exclude (aka "Do not protect") list
          implode( '" AND path NOT LIKE "%.', array_map("mysql_escape_string", $_POST['file_types'])) . '"' 
        : 
          ''
      ) . '
      GROUP BY images.id
      ORDER BY storage_category_id ASC;';

  $result = pwg_query($query);

  unset($last_physical_category);
  $return = array('infos' => array(), 'errors' => array());

  $cat_ids_written_htaccess = array();

  while ($row = mysql_fetch_array($result)) {
    if (!isset($last_physical_category) || $last_physical_category !== $row['storage_category_id']) {
      // We are in another category (or we just started)
      if (isset($file))
        writeAllHtaccessFiles(dirname($file), $public, $simulate, $return);

      $file = preg_replace('|(\.\/)+|',
                          './',
                          PHPWG_ROOT_PATH .
                            dirname($row['path']) .
                            '/.htaccess'
                         );

      array_push($cat_ids_written_htaccess, $row['storage_category_id']);

      $public = array();
      $last_physical_category = $row['storage_category_id'];
    }

    if (strstr($row['status'], 'public') !== FALSE) {
      if (!isset($public))
        $public = array();
      array_push($public, basename($row['path']));
    }
  }
  if (isset($file) && isset($public))
    writeAllHtaccessFiles(dirname($file), $public, $simulate, $return);
  
  writeAllDefaultHtAccessFiles($cat_fulldirs, $cat_ids, $cat_ids_written_htaccess, $simulate, $return);

  return $return;
}

function secureImages_htaccess_removal($simulate = FALSE) {
  if (!defined('PHPWG_ROOT_PATH'))
  {
    die('Hacking attempt!');
  }

  $opts['category_id'] = '';
  $opts['recursive'] = true;

  if (isset($_POST['cat']))
  {
    $opts['category_id'] = $_POST['cat'];
    // recursive ?
    if (!isset($_POST['subcats-included']) or $_POST['subcats-included'] != 1)
    {
      $opts['recursive'] = false;
    }
  }
  //  $start = get_moment();
  if (!isset($site_id))
    $site_id = 1;

  // filling $cat_ids : all categories required
  $cat_ids = array();

  $query = '
    SELECT id
      FROM '.CATEGORIES_TABLE.'
      WHERE site_id = '.$site_id.'
      AND dir IS NOT NULL';
  if (is_numeric($opts['category_id']))
  {
    if ($opts['recursive'])
    {
      $query.= '
        AND uppercats REGEXP \'(^|,)'.$opts['category_id'].'(,|$)\'
        ';
    }
    else
    {
      $query.= '
        AND id = '.$opts['category_id'].'
        ';
    }
  }
  $query.= '
    ;';
  $result = pwg_query($query);
  while ($row = mysql_fetch_array($result))
  {
    array_push($cat_ids, $row['id']);
  }

  if (count($cat_ids) == 0)
  {
    break;
  }

  // Getting directories of categories
  $dirs = get_fulldirs($cat_ids);
  if (count($dirs) == 0)
    break;

  $return = array('infos' => array(), 'errors' => array());

  foreach (array_values($dirs) as $dirs_elt) {
    removeAllHtaccessFiles($dirs_elt, $simulate, $return);
  }

  return $return;
}

function writeAllDefaultHtAccessFiles($dirs, $all_ids, $exclude_ids, $simulate, &$return) {
  foreach ($all_ids as $all_ids_elt) {
    if (in_array($all_ids_elt, $exclude_ids))
      break;
    writeAllHtaccessFiles($dirs[$all_ids_elt], array(), $simulate, $return);
  }
}

function writeAllHtaccessFiles( $dir, $publicImages, $simulate, &$return ) {
  writeHtaccessFile($dir.'/.htaccess', $publicImages, $simulate, $return, 0);
  writeHtaccessFile($dir.'/thumbnail/.htaccess', $publicImages, $simulate, $return, 1);
  if (file_exists($dir.'/pwg_high'))
    writeHtaccessFile($dir.'/pwg_high/.htaccess', $publicImages, $simulate, $return, 0);
}

function writeHtaccessFile( $file, $publicImages, $simulate, &$return, $isThumb ) {
  global $conf;

  if (!is_writable_extended($file)) {
    array_push(
               $return['errors'],
               array('path' => $file,
                     'type' => 'SECUREIMAGES-HTACCESS-NOT-WRITEABLE'
                    )
              );
    return;
  }
  elseif ($simulate) {
    array_push(
               $return['infos'],
               array('path' => $file,
                     'info' => 'successfully created'
                    )
              );
    return;
  }

  $hdl = @fopen( $file, 'w' );
  
  if (!$hdl) {
    array_push(
               $return['errors'],
               array('path' => $file,
                     'type' => 'SECUREIMAGES-UNKNOWN'
                    )
              );
    return;
  }

  if (isset($_POST['file_types']) && count($_POST['file_types']) > 0) {
    fwrite($hdl, '<FilesMatch "\.(' . 
      implode('|', $_POST['file_types']) . 
      ')$>' .
      "\nallow from all\n</FilesMatch>\n\n"
      );
  }

  if (count($publicImages) > 0) {
    fwrite($hdl, '<FilesMatch "(' .
      ($isThumb == 1 ? $conf['prefix_thumbnail'] : '') .
      implode('|'.($isThumb == 1 ? $conf['prefix_thumbnail'] : ''), $publicImages) .
      ')">' .
        "\nallow from all\n</FilesMatch>\n\n"
      );
  }
  fwrite($hdl, 'deny from all');
  fclose($hdl);

  array_push(
             $return['infos'],
             array('path' => $file,
                   'info' => 'successfully created'
                  )
            );
}

function removeAllHtaccessFiles( $dir, $simulate, &$return ) {
  removeHtaccessFile($dir.'/.htaccess', $simulate, $return);
  removeHtaccessFile($dir.'/thumbnail/.htaccess', $simulate, $return);
  if (file_exists($dir.'/pwg_high'))
    removeHtaccessFile($dir.'/pwg_high/.htaccess', $simulate, $return);
}

function removeHtaccessFile( $file, $simulate, &$return ) {
  if (file_exists($file)) {
    if ($simulate == FALSE) { 
      unlink($file) ?  
        array_push(
          $return['infos'],
          array('path' => $file,
                'info' => 'successfully removed'
          )
        )
      : array_push(
          $return['errors'],
          array('path' => $file,
                'type' => 'SECUREIMAGES-HTACCESS-NOT-REMOVABLE'
          )
        );
    }
    else {
      is_writable_extended($file) ?  
        array_push(
          $return['infos'],
          array('path' => $file,
                'info' => 'successfully removed'
          )
        )
      : array_push(
          $return['errors'],
          array('path' => $file,
                'type' => 'SECUREIMAGES-HTACCESS-NOT-REMOVABLE'
          )
        );
    }
  }
}

function is_writable_extended($file) {
  if ( (!file_exists($file) and is_writable(dirname($file))) or
       is_writable($file)
     )
    return true;
}

?>
